# On Fastify

{% hint style="success" %}
This is the official documentation of the `@forestadmin/agent` Node.js agent.
{% endhint %}

If you already have an application running using [Fastify](https://www.fastify.io/), the easiest way to attach the Forest Admin agent would use the `mountOnFastify` function, just like in the following example:

```javascript
require('dotenv').config();

const { fastify } = require('fastify');
const { createAgent } = require('@forestadmin/agent');
const { createSqlDataSource } = require('@forestadmin/datasource-sql');

const agent = createAgent({
  authSecret: process.env.FOREST_AUTH_SECRET,
  envSecret: process.env.FOREST_ENV_SECRET,
  isProduction: process.env.NODE_ENV === 'production',
});

const app = fastify();

// This function must be called before other middlewares.
await agent.mountOnFastify(app).start();

app.listen(3000);
```

### Using Fastify v4.x

You should use [@fastify/middie](https://github.com/fastify/middie) library to be able to use Fastify v4.x with Forest Admin.

This library adds middleware support to Fastify.

```javascript
const fastifyAppV4 = Fastify();
await fastifyAppV4.register(import('@fastify/middie'));
agent.mountOnFastify(fastifyAppV4);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-nodejs/getting-started/install/expose-an-http-endpoint/using-fastify.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
